config/routes.rb
Rails.application.routes.draw do
  resources :strength_trainings
  resources :endurance_trainings
  resources :strength_trainings
  resources :endurance_trainings
  resources :strength_trainings
  resources :strength_trainings
  resources :endurance_trainings
  resources :trainings
  resources :statistic_entries
  resources :training_days
  resources :users

  get 'weekoverview/index'
  post '/weekoverview/index', to: 'weekoverview#index'

  get 'trainings/new/:date', to: 'trainings#new'

  get 'statistic_entries/new/:date', to: 'statistic_entries#new'

  get 'sessions/new'
  get    'help'    => 'static_pages#help'
  get    'about'   => 'static_pages#about'
  get    'contact' => 'static_pages#contact'
  get    'signup'  => 'users#new'
  get    'login'   => 'sessions#new'
  post   'login'   => 'sessions#create'
  delete 'logout'  => 'sessions#destroy'

  root :to => 'sessions#new'

end

app/models/training.rb
class Training < ActiveRecord::Base
  belongs_to :training_day
end

app/controllers/trainings_controller.rb
class TrainingsController < ApplicationController
  before_action :set_training, only: [:show, :edit, :update, :destroy]

  include SessionsHelper
  # GET /trainings
  # GET /trainings.json
  def index
    @trainings = Training.all
  end

  # GET /trainings/1
  # GET /trainings/1.json
  def show
  end

  # GET /trainings/new
  def new
    @date = params[:date]
    if @date != nil
      @date = Date.parse(@date)
    else
      @date = Date.today
    end
    @training = Training.new
    return @training, @date
  end

  # GET /trainings/1/edit
  def edit
  end

  # POST /trainings
  # POST /trainings.json
  def create
    @training = Training.new(training_params)

    @date = params[:date]
    if @date == nil
      @date = Date.new
    else
      @date = Date.parse(@date)
    end

    trainingsDay = TrainingDay.find_by(date: @date, user: current_user)

    if trainingsDay != nil
      @training.training_day = trainingsDay
    else
      @trainingDay = TrainingDay.new
      @trainingDay.date = @date
      @trainingDay.user = current_user
      @trainingDay.save
      @training.training_day = @trainingDay
    end

    respond_to do |format|
      if @training.save
        format.html { redirect_to @training, notice: 'Training was successfully created.' }
        format.json { render :show, status: :created, location: @training }
      else
        format.html { render :new }
        format.json { render json: @training.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /trainings/1
  # PATCH/PUT /trainings/1.json
  def update
    respond_to do |format|
      if @training.update(training_params)
        format.html { redirect_to @training, notice: 'Training was successfully updated.' }
        format.json { render :show, status: :ok, location: @training }
      else
        format.html { render :edit }
        format.json { render json: @training.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /trainings/1
  # DELETE /trainings/1.json
  def destroy
    @training.destroy
    respond_to do |format|
      format.html { redirect_to weekoverview_index_url, notice: 'Training was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
  # Use callbacks to share common setup or constraints between actions.
  def set_training
    @training = Training.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def training_params
    params.require(:training).permit(:name, :type, :note, :sets, :length, :reruns, :weight)
  end

end

app/helpers/trainings_helper.rb
module TrainingsHelper
end

app/views/trainings/_form.html.erb
<%= form_for(@training) do |f| %>
    <% if @training.errors.any? %>
        <div id="error_explanation">
          <h2><%= pluralize(@training.errors.count, "error") %> prohibited this training from being saved:</h2>

          <ul>
            <% @training.errors.full_messages.each do |message| %>
                <li><%= message %></li>
            <% end %>
          </ul>
        </div>
    <% end %>

    <div class="field">
      <label class="control-label" for="date">Datum:</label>
      <input type="date" name="date" id="date" placeholder="Ansichtsdatum" value="<%= @date.to_s%>">
    </div>
    <div class="field">
      <%= f.label :name %><br>
      <%= f.text_field :name %>
    </div>
    <div class="field">
      <%= f.label :type %><br>
      <%= f.select :type, [['StrengthTraining','StrengthTraining'],['EnduranceTraining','EnduranceTraining']] %>
    </div>
    <div class="field">
      <%= f.label :note %><br>
      <%= f.text_area :note %>
    </div>

    <%# strengthTraining fields %>

    <div class="field StrengthTraining">
      <%= f.label :sets %><br>
      <%= f.number_field :sets %>
    </div>
    <div class="field StrengthTraining">
      <%= f.label :weight %><br>
      <%= f.number_field :weight %>
    </div>
    <div class="field StrengthTraining">
      <%= f.label :reruns %><br>
      <%= f.number_field :reruns %>
    </div>

    <%# EnduranceTraining fields %>

    <div class="field EnduranceTraining" style="display: none">
      <%= f.label :length %><br>
      <%= f.number_field :length %>
    </div>

    <div class="actions">
      <%= f.submit :class => 'btn btn-primary' %>
    </div>
<% end %>

app/views/trainings/edit.html.erb
<h1>Editing Training</h1>

<%= render 'layouts/header' %>
<div class="container">
  <%= render 'form' %>
</div>

<%= link_to 'Show', @training , :class => 'btn btn-info'%>
<%= link_to 'Destroy', @training, method: :delete, data: { confirm: 'Are you sure?' } , :class => 'btn btn-danger' %>
<%= link_to 'Back', weekoverview_index_path , :class => 'btn btn-info' %>

app/views/trainings/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Trainings</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Type</th>
      <th>Note</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @trainings.each do |training| %>
      <tr>
        <td><%= training.name %></td>
        <td><%= training.type %></td>
        <td><%= training.note %></td>
        <td><%= link_to 'Show', training %></td>
        <td><%= link_to 'Edit', edit_training_path(training) %></td>
        <td><%= link_to 'Destroy', training, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Training', new_training_path %>

app/views/trainings/new.html.erb
<%= javascript_include_tag 'trainingChange' %>
<%= render "layouts/header" %>
<div class="row" style="margin: 1%">
  <div class="col-md-6 col-md-offset-3 panel-group ">
    <div class="panel panel-primary">
      <div class="panel-heading"><h2>new Training </h2></div>
      <div class="panel-body">
        <%= render 'form' %>
      </div>
      <div style="float: right">
        <%= link_to 'Back', weekoverview_index_path, :class => 'btn btn-info' %>
      </div>
    </div>
  </div>
</div>

app/views/trainings/show.html.erb
<%= render 'layouts/header' %>
<p>
  <strong>Name:</strong>
  <%= @training.name %>
</p>

<p>
  <strong>Type:</strong>
  <%= @training.type %>
</p>

<p>
  <strong>Note:</strong>
  <%= @training.note %>
</p>

<%= link_to 'Edit', edit_training_path(@training) , :class => 'btn btn-info' %>
<%= link_to 'Back', weekoverview_index_path , :class => 'btn btn-info'%>